import org.apache.commons.mail.EmailAttachment;
import org.apache.commons.mail.EmailException;
import org.apache.commons.mail.MultiPartEmail;
import org.apache.commons.mail.SimpleEmail;

import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import java.util.Properties;

public class QuickMailer {
    public static void main(String[] args) {
        QuickMailerForm form = new QuickMailerForm();
        form.setVisible(true);
    }

    public static void sendMessage(String aFrom, String aTo, String aSubject, String aMessageText) throws Exception {
        InternetAddress from = new InternetAddress(aFrom, "From");
        InternetAddress to = new InternetAddress(aTo, "To");

        Properties props = new Properties();
        props.put("mail.debug", "true");
        props.put("mail.transport.protocol", "smtp");
        props.put("mail.smtp.host", "localhost");
        props.put("mail.smtp.port", "25");
        Session session = Session.getDefaultInstance(props);

        Transport transport = session.getTransport();

        MimeMessage message = new MimeMessage(session);
        message.setFrom(from);
        message.setRecipient(Message.RecipientType.TO, to);
        message.setSubject(aSubject, "utf-8");
        message.setContent(aMessageText, "text/plain; charset=utf-8");

        transport.connect();
        transport.sendMessage(message, new Address[]{to});
        transport.close();
    }

    public static void sendMessageCommonsEMail(String aFrom, String aTo, String aSubject, String aMessageText) throws EmailException {
        SimpleEmail email = new SimpleEmail();
        email.setHostName("localhost");
        email.setFrom(aFrom, "From");
        email.addTo(aTo, "To");
        email.setSubject(aSubject);
        email.setMsg(aMessageText);
        email.send();
    }

    public static void sendMessageWithAttachment(String aFrom, String aTo, String aSubject, String aMessageText) throws EmailException {
        EmailAttachment attachment = new EmailAttachment();
        attachment.setPath("attachments/attachment.zip");
        attachment.setDisposition(EmailAttachment.ATTACHMENT);
        attachment.setDescription("Файл-приложение к письму");
        attachment.setName("attachment.zip");

        MultiPartEmail email = new MultiPartEmail();
        email.setHostName("localhost");
        email.setFrom(aFrom, "From");
        email.addTo(aTo, "To");
        email.setSubject(aSubject);
        email.setMsg(aMessageText);

        email.attach(attachment);

        email.send();
    }

    public static void receive(String aHost, String aUserName, String aPassword) throws MessagingException {
        Properties props = new Properties();
        Session session = Session.getDefaultInstance(props, null);

        Store store = session.getStore("pop3");
        store.connect(aHost, aUserName, aPassword);

        Folder folder = store.getFolder("INBOX");
        folder.open(Folder.READ_ONLY);

        Message message[] = folder.getMessages();

        for (int i = 0, n = message.length; i < n; i++) {
            System.out.println(i + ": " + message[i].getFrom()[0] + "\t" + message[i].getSubject());
        }

        folder.close(false);
        store.close();
    }
}
