import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class QuickMailerForm extends JFrame {
    private JTextField _fieldTo;
    private JTextField _fieldSubject;
    private JEditorPane _message;
    private JButton _buttonSend;

    public QuickMailerForm() throws HeadlessException {
        setTitle("Быстро Мэйлер");

        setDefaultCloseOperation(EXIT_ON_CLOSE);

        createLayout();
        createActions();

        pack();
        setSize(700, 560);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((int) (screenSize.getWidth() - 700)/2, (int) ((screenSize.getHeight() - 560)/2));
    }

    private void createActions() {
        _buttonSend.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    QuickMailer.sendMessage("alex@jdnevnik.com", _fieldTo.getText(), _fieldSubject.getText(),
                            _message.getDocument().getText(0, _message.getDocument().getLength()));
                } catch (Exception e1) {
                    e1.printStackTrace();
                }
            }
        });
    }

    private void createLayout() {
        JPanel labelsPanel = new JPanel(new GridLayout(2, 1));
        labelsPanel.add(new JLabel("EMail получателя:", JLabel.RIGHT));
        labelsPanel.add(new JLabel("Тема письма:", JLabel.RIGHT));

        JPanel buttonsPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        _buttonSend = new JButton("Отправить");
        buttonsPanel.add(_buttonSend);

        JPanel fieldsPanel = new JPanel(new GridLayout(2, 1));
        _fieldTo = new JTextField();
        _fieldSubject = new JTextField();
        fieldsPanel.add(_fieldTo);
        fieldsPanel.add(_fieldSubject);

        JPanel controlsPanel = new JPanel(new BorderLayout(5, 5));
        controlsPanel.add(labelsPanel, BorderLayout.WEST);
        controlsPanel.add(fieldsPanel, BorderLayout.CENTER);

        JPanel mainPanel = new JPanel(new BorderLayout(5, 5));

        _message = new JEditorPane("text/rtf", "");
        mainPanel.add(controlsPanel, BorderLayout.NORTH);
        mainPanel.add(new JScrollPane(_message), BorderLayout.CENTER);
        mainPanel.add(buttonsPanel, BorderLayout.SOUTH);

        mainPanel.setBorder(new EmptyBorder(5, 5, 5, 5));

        setContentPane(mainPanel);
    }
}
